VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Stroke"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
Private db As Database
Private tbStroke As TableDef
Private rec As Recordset
Private opened As Boolean
Const FREE = 1, BACK = 2, BREAST = 3, FLY = 4, IM = 5
Const Relay = 6, MEDRELAY = 7, DIVING = 8

Public Sub setDB(datab As Database)
Set db = datab
End Sub
Public Function getTableName() As String
getTableName = "Strokes"
End Function
Public Function isRelay(key As Long) As Boolean
isRelay = (key = Relay) Or (key = MEDRELAY)
End Function

Public Sub createTable(datab As Database)
Dim ind As New Indexer

Set db = datab
ind.makeTable db, "Strokes"

ind.createKey "strokeKey"
ind.createText "strokeName", 12
ind.makeIndex "strokeKey", True
ind.addTable

Set rec = db.OpenRecordset("Strokes", dbOpenTable)
addField "Free"
addField "Back"
addField "Breast"
addField "Fly"
addField "IM"
addField "Free Relay"
addField "Medley Relay"
addField "Diving"
rec.Close
opened = False
End Sub
Public Sub openTable()
If Not opened Then
Set rec = db.OpenRecordset("Strokes", dbOpenTable)
End If
End Sub
Private Sub addField(s As String)
rec.AddNew
rec![strokeName] = s
rec.update
End Sub
Public Function getStrokeKey(s$) As Integer
Dim Index As Integer
Index = 1
Select Case Left$(UCase$(s$), 2)
 Case "FR"
   Index = 1
    If UCase$(s$) = "FREE RELAY" Then
        Index = Relay
      End If
 Case "BA"
   Index = 2
 Case "BR"
   Index = 3
 Case "FL", "BU"
   Index = 4
 Case "IM"
   Index = 5
 Case "RE"
   Index = 6
 Case "ME"
   Index = 7
 Case "DI"
   Index = DIVING
End Select
getStrokeKey = Index
End Function
Public Function getStrokeDist(stroke_index As Integer, dist As Integer, course As String)

Dim skey As Integer
Select Case stroke_index
  Case 1 To 7
    skey = FREE
  Case 8 To 11
    skey = BACK
  Case 12 To 15
    skey = BREAST
  Case 16 To 19
    skey = FLY
  Case 20 To 22
    skey = IM
End Select

Select Case stroke_index
  Case 1, 8, 12, 16
    dist = 25
  Case 2, 9, 13, 17
    dist = 50
  Case 3, 10, 14, 18, 20
    dist = 100
  Case 4, 11, 15, 19, 21
    dist = 200
  Case 22
    dist = 400
  Case 5
    If course = "YDS" Then
      dist = 500
    Else
      dist = 400
    End If
  Case 6
  If course = "YDS" Then
      dist = 1000
    Else
      dist = 800
    End If
  Case 7
  If course = "YDS" Then
      dist = 1650
    Else
      dist = 1500
    End If
End Select

getStrokeDist = skey
End Function
Public Function getStrokeName(Index As Integer) As String
Dim stroke$

Select Case Index
  Case 1
  stroke$ = "Free"
  Case 2
  stroke$ = "Back"
  Case 3
  stroke$ = "Breast"
  Case 4
  stroke$ = "Fly"
  Case 5
  stroke$ = "IM"
  Case 6
  stroke$ = "Free Relay"
  Case 7
  stroke$ = "Medley Relay"
  Case 8
  stroke$ = "Diving"
  End Select
getStrokeName = stroke$
End Function
Public Function getCanadianStrokeName(Index As Integer) As String
Dim stroke$

Select Case Index
  Case 1
  stroke$ = "Free/Libre"
  Case 2
  stroke$ = "Back/Dos"
  Case 3
  stroke$ = "Breast/Brasse"
  Case 4
  stroke$ = "Fly/Papillon"
  Case 5
  stroke$ = "IM/QNI"
  Case 6
  stroke$ = "FR/RL"
  Case 7
  stroke$ = "MR/RQN"
  Case 8
  stroke$ = "Diving"
  End Select
getCanadianStrokeName = stroke$

End Function

Public Function getFree() As Integer
getFree = FREE
End Function
Public Function getBack() As Integer
getBack = BACK
End Function
Public Function getBreast() As Integer
getBreast = BREAST
End Function
Public Function getFly() As Integer
getFly = FLY
End Function
Public Function getFreeRelay() As Integer
getFreeRelay = Relay
End Function
Public Function getMedrelay() As Integer
getMedrelay = MEDRELAY
End Function
Public Function getDiving() As Integer
getDiving = DIVING
End Function
Public Function getIM() As Integer
getIM = IM

End Function

