VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SwimEvent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit
'This class is used to enumerate swimmers in an event
Private db As Database
Private rec As Recordset
Private tm As New times
Private recopen As Boolean
Private count As Integer
Private swim_count As Integer
Private event_type As Integer   'seed, prelim, final, preseed, finalseed
Private recheat As Integer  'keeps current heat of returned kid
Private newLine As Boolean   'trueif last was blank line
Private final_flag As Boolean
Private comb As New Combined
Const E_Prelim = 0, E_Results = 1, E_Finals = 3, E_Seeding = 2, E_FSeeding = 4, E_Swimoff = 5, E_Semis = 6
Public Sub setDB(datab As Database)
Set db = datab
comb.setDB db
End Sub
Public Function getEventNumber() As Integer
If Not rec.BOF Then getEventNumber = rec![eventkey]
End Function
Public Function EPrelim() As Integer
EPrelim = E_Prelim
End Function
Public Function ESemis() As Integer
ESemis = E_Semis
End Function
Public Function EResults() As Integer
EResults = E_Results
End Function
Public Function EFinals() As Integer
EFinals = E_Finals
End Function
Public Function ESeeding() As Integer
ESeeding = E_Seeding
End Function
Public Function FSeeding() As Integer
FSeeding = E_FSeeding
End Function
Public Function ESwimOff() As Integer
ESwimOff = E_Swimoff
End Function
Public Sub getEvent(evnum As Integer, Index As Integer)
event_type = Index      'save to be persistent
Select Case Index
  Case E_Prelim
    getEventbySeedTime evnum
  Case E_Results
    getEventByResultTime evnum
  Case E_Finals
    geteventbyFinalTime evnum
  Case E_Seeding
    getPrelimSeeding evnum
  Case E_FSeeding
    getFinalsSeeding evnum
  Case E_Swimoff
    getSwimoffSeeding evnum
  Case E_Semis
    getSemiSeeding evnum
End Select
End Sub

Public Sub getEventbySeedTime(evnum As Integer)
Dim qry$
count = 1
final_flag = False
qry$ = "SELECT DISTINCTROW Swimmer.swimmerkey, Swimmer.Frname, Swimmer.Lname, Teams.TeamCode, events.eventkey, Entry.Unofficial, Entry.SeedTime " & _
"FROM ((Swimmer INNER JOIN Entry ON Swimmer.SwimmerKey = Entry.SwimmerKey) INNER JOIN Teams ON Swimmer.TeamKey = Teams.TeamKey) INNER JOIN Events ON Entry.EventKey = Events.EventKey " & _
"Where(((Events.Eventkey) =" + Str$(evnum) + ") ) ORDER BY Entry.SeedTime;"

recClose
Set rec = db.OpenRecordset(qry$, dbOpenDynaset)
setCount
End Sub
Private Sub setCount()
recopen = True
If Not rec.EOF Then rec.MoveLast
swim_count = rec.RecordCount
If Not rec.BOF Then rec.moveFirst
End Sub
Public Sub getEventByResultTime(evnum As Integer)
Dim qry$
count = 1
final_flag = False
qry$ = "SELECT DISTINCTROW Swimmer.swimmerkey, Swimmer.Frname, Swimmer.Lname, Events.eventkey, Teams.TeamCode, Results.Result,Entry.Unofficial, Results.DQ " & _
"FROM (((Swimmer INNER JOIN Entry ON Swimmer.SwimmerKey = Entry.SwimmerKey) INNER JOIN Teams ON Swimmer.TeamKey = Teams.TeamKey) INNER JOIN Events ON Entry.EventKey = Events.EventKey) INNER JOIN Results ON Entry.Entrykey = Results.Entrykey " & _
"Where (((Events.Eventkey) = " + Str$(evnum) + ") And ((RESULTS.SCRATCH) = False) And ((RESULTS.Racetype) = 1 Or (RESULTS.Racetype) = 2) And ((RESULTS.DQ) = False)) " & _
"ORDER BY Results.DQ DESC, Results.Result;"
recClose
Set rec = db.OpenRecordset(qry$, dbOpenDynaset)
setCount

End Sub
Public Sub getPrelimSeeding(evnum As Integer)
Dim qry$
count = 1
recheat = 1
final_flag = False
If comb.isCombined(evnum) Then
  qry = comb.getQuery(evnum)
Else

qry$ = "SELECT swimmer.swimmerkey, Swimmer.Frname, Results.DQ, Swimmer.Lname, Entry.eventkey,Entry.Unofficial, Results.Result, Results.Backup, Entry.Points, Entry.seedtime,Entry.Unofficial, Teams.TeamCode, Results.Scratch, Results.ResultKey, Seeding.Heat, Seeding.Lane " & _
"FROM ((Swimmer INNER JOIN (Results INNER JOIN Entry ON Results.Entrykey = Entry.Entrykey) ON Swimmer.SwimmerKey = Entry.SwimmerKey) INNER JOIN Teams ON Swimmer.TeamKey = Teams.TeamKey) INNER JOIN Seeding ON Results.ResultKey = Seeding.ResultKey " & _
"Where (((RESULTS.SCRATCH) = False) And ((RESULTS.racetype) = 1 Or (RESULTS.racetype) = 2) And ((Entry.EventKey) = " + Str$(evnum) + ")) " & _
"ORDER BY Seeding.Heat, Seeding.Lane;"
End If
recClose
Set rec = db.OpenRecordset(qry$, dbOpenDynaset)
'While Not rec.EOF
'  Debug.Print rec![lname], rec![seedTime], rec![Heat]; rec![lane]
'  rec.MoveNext
'Wend
'rec.MoveFirst
setCount

End Sub
Public Sub getSwimoffSeeding(evnum As Integer)
Dim qry$
count = 1
recheat = 1
final_flag = False
If comb.isCombined(evnum) Then
  qry = comb.getQuery(evnum)
Else

qry$ = "SELECT swimmer.swimmerkey, Swimmer.Frname, Results.DQ, Swimmer.Lname, Entry.eventkey,Entry.Unofficial, Results.Result, Results.Backup, Entry.Points, Entry.seedtime,Entry.Unofficial, Teams.TeamCode, Results.Scratch, Results.ResultKey, Seeding.Heat, Seeding.Lane " & _
"FROM ((Swimmer INNER JOIN (Results INNER JOIN Entry ON Results.Entrykey = Entry.Entrykey) ON Swimmer.SwimmerKey = Entry.SwimmerKey) INNER JOIN Teams ON Swimmer.TeamKey = Teams.TeamKey) INNER JOIN Seeding ON Results.ResultKey = Seeding.ResultKey " & _
"Where (((RESULTS.SCRATCH) = False) And ((RESULTS.racetype) = 4) And ((Entry.EventKey) = " + Str$(evnum) + ")) " & _
"ORDER BY Seeding.Heat, Seeding.Lane;"
End If
recClose
Set rec = db.OpenRecordset(qry$, dbOpenDynaset)
setCount

End Sub
Public Sub getSemiSeeding(evnum As Integer)
Dim qry$
count = 1
recheat = 1
final_flag = False
If comb.isCombined(evnum) Then
  qry = comb.getQuery(evnum)
Else

qry$ = "SELECT swimmer.swimmerkey, Swimmer.Frname, Results.DQ, Swimmer.Lname, Entry.eventkey,Entry.Unofficial, Results.Result, Results.Backup, Entry.Points, Entry.seedtime,Entry.Unofficial, Teams.TeamCode, Results.Scratch, Results.ResultKey, Seeding.Heat, Seeding.Lane " & _
"FROM ((Swimmer INNER JOIN (Results INNER JOIN Entry ON Results.Entrykey = Entry.Entrykey) ON Swimmer.SwimmerKey = Entry.SwimmerKey) INNER JOIN Teams ON Swimmer.TeamKey = Teams.TeamKey) INNER JOIN Seeding ON Results.ResultKey = Seeding.ResultKey " & _
"Where (((RESULTS.SCRATCH) = False) And ((RESULTS.racetype) = " + Str$(E_Semis) + ") And ((Entry.EventKey) = " + Str$(evnum) + ")) " & _
"ORDER BY Seeding.Heat, Seeding.Lane;"
End If
recClose
Set rec = db.OpenRecordset(qry$, dbOpenDynaset)
setCount

End Sub
Public Sub getFinalsSeeding(evnum As Integer)
Dim qry$
count = 1
recheat = 1

final_flag = True
qry$ = "SELECT DISTINCTROW Events.Eventkey, Swimmer.swimmerkey, Swimmer.Frname, Swimmer.Lname, Entry.Unofficial,Teams.TeamCode, Seeding.Heat, Seeding.Lane, Results.Result, Results_1.* " & _
"FROM (Events INNER JOIN (((Swimmer INNER JOIN Teams ON Swimmer.TeamKey = Teams.TeamKey) INNER JOIN Entry ON Swimmer.SwimmerKey = Entry.SwimmerKey) INNER JOIN Results ON Entry.Entrykey = Results.Entrykey) ON Events.EventKey = Entry.EventKey) INNER JOIN (Seeding INNER JOIN Results AS Results_1 ON Seeding.ResultKey = Results_1.ResultKey) ON Entry.Entrykey = Results_1.Entrykey " & _
"Where(((Events.Eventkey) = " + Str$(evnum) + ") And ((Results_1.Racetype) = 3) And ((RESULTS.Racetype) = 2)) and (seeding.heat>0) and (Results_1.Scratch = false)" & _
"ORDER BY Seeding.Heat, Seeding.Lane;"
qry$ = "SELECT Swimmer.Swimmerkey, Swimmer.Frname, Swimmer.Lname, Teams.TeamCode, Entry.Unofficial, Seeding.Heat, Seeding.Lane, Results.raceType, Results.Result, Entry.EventKey, Results.Scratch, Results_1.raceType, Results_1.Result, Results_1.DQ, Results_1.Place, Results_1.Backup, Results_1.ResultKey " & _
"FROM Seeding INNER JOIN (Results AS Results_1 INNER JOIN (((Swimmer INNER JOIN Teams ON Swimmer.TeamKey = Teams.TeamKey) INNER JOIN Entry ON Swimmer.SwimmerKey = Entry.SwimmerKey) INNER JOIN Results ON Entry.Entrykey = Results.Entrykey) ON Results_1.Entrykey = Entry.Entrykey) ON Seeding.ResultKey = Results_1.ResultKey " & _
"Where (((Seeding.heat) > 0) And ((RESULTS.racetype) = 1 Or (RESULTS.racetype) = 2) And ((Entry.eventkey) = " + Str$(evnum) + ") And ((RESULTS_1.SCRATCH) = False) And ((Results_1.racetype) = 3)) " & _
"ORDER BY Seeding.Heat, Seeding.Lane;"

recClose
Set rec = db.OpenRecordset(qry$, dbOpenDynaset)
setCount

End Sub
Public Sub geteventbyFinalTime(evnum As Integer)
Dim qry$
count = 1
qry$ = "SELECT DISTINCTROW Events.Eventkey, Swimmer.swimmerkey, Swimmer.Frname, Swimmer.Lname, Teams.TeamCode, Seeding.Heat, Results.DQ, Entry.Unofficial,Results.Result, Results.raceType " & _
"FROM Events INNER JOIN ((((Swimmer INNER JOIN Teams ON Swimmer.TeamKey = Teams.TeamKey) INNER JOIN Entry ON Swimmer.SwimmerKey = Entry.SwimmerKey) INNER JOIN Results ON Entry.Entrykey = Results.Entrykey) INNER JOIN Seeding ON Results.ResultKey = Seeding.ResultKey) ON Events.EventKey = Entry.EventKey " & _
"Where (((Events.Eventkey) = " + Str$(evnum) + ") And ((RESULTS.Racetype) = 3)) and (seeding.heat>0) and (Results.Scratch = false)" & _
"ORDER BY Seeding.Heat DESC , Results.DQ DESC , Results.Result;"

recClose
Set rec = db.OpenRecordset(qry$, dbOpenDynaset)
setCount

End Sub
Public Function getEvString() As String
Dim s$, tw As Long
Dim DQ As Boolean
DQ = False

Select Case event_type
  Case E_Prelim        'get seeding of prelims
    tm.setSingle rec![seedTime]
    getEvString = get_res_string(DQ)
  Case E_Results            'results of prelms
    tm.setSingle rec![result]
    DQ = rec![DQ]
    getEvString = get_res_string(DQ)
  Case E_Finals            'results of finals
    tm.setSingle rec![result]
    DQ = rec![DQ]
    If recheat = rec![heat] Then
        getEvString = get_res_string(DQ)
        newLine = False
    Else
        recheat = rec![heat]
        getEvString = ""
        newLine = True
    End If
  Case E_Seeding        'prelims seeding
    If rec![heat] = recheat Then
        getEvString = get_seed_string
        newLine = False
    Else
      recheat = rec![heat]
      getEvString = ""
      newLine = True
    End If
   Case E_FSeeding            'finals seeding
     If rec![heat] = recheat Then
        getEvString = get_seed_string
        newLine = False
     Else
      recheat = rec![heat]
      getEvString = ""
      newLine = True
     End If

End Select
  
End Function
Private Function get_res_string(DQ As Boolean) As String
Dim s$, tw As Long

s$ = Str$(count) + " " + rec![Frname] + " " + rec![Lname]
tw = Meet6.Picture1.textWidth(s$)
'tw = 700

s$ = Str$(count) + " " + rec![Frname] + " " + rec![Lname] + Chr$(9)
If tw < 1410 Then
  s$ = s$ + Chr$(9)
End If
s$ = s$ + rec![teamcode] + Chr$(9)
If Not DQ Then
    s$ = s$ + tm.getFormatted
Else
    s$ = s$ + " DQ"
End If
get_res_string = s$
count = count + 1

End Function
Private Function get_seed_string() As String
Dim s$, tw As Long

s$ = Str$(rec![heat]) + Str$(rec![lane]) + " " + rec![Frname] + " " + rec![Lname]
tw = Meet6.Picture1.textWidth(s$)
s$ = s$ + Chr$(9)
If tw < 1410 Then
  s$ = s$ + Chr$(9)
End If
s$ = s$ + rec![teamcode] + Chr$(9)
If event_type = 2 Then
  tm.setSingle rec![seedTime]
Else
  tm.setSingle rec![Results.result]
End If
s$ = s$ + tm.getFormatted
get_seed_string = s$
End Function
Public Sub moveNext()
If Not newLine Then
    rec.moveNext
End If
End Sub
Public Function EOF() As Boolean
EOF = rec.EOF
End Function
Public Sub moveFirst()
If Not rec.BOF Then
    rec.moveFirst
End If
End Sub
Public Function getSwimmerKey() As Long
getSwimmerKey = rec![swimmerKey]
End Function
Public Function getName() As String
getName = rec![Frname] + " " + rec![Lname]
End Function
Public Function getHeat() As Integer
If Not rec.EOF Then
  If Not IsNull(rec![heat]) Then
    getHeat = rec![heat]
  Else
    getHeat = 0
  End If
End If
End Function
Public Function getLane() As Integer
If Not rec.EOF Then getLane = rec![lane]
End Function
Public Sub recClose()
If recopen Then
  If Not rec.EOF Then rec.Close
  recopen = False
End If
End Sub
Public Function getClub() As String
getClub = rec![teamcode]
End Function
Public Function getTime() As Single
If final_flag Then
    getTime = rec![results_1.result]
Else
    getTime = rec![result]
End If
End Function
Public Function getBackup() As Single
getBackup = rec![BACKUP]
End Function
Public Function getDQ() As Boolean
getDQ = rec![DQ]
End Function
Public Function getScratch() As Boolean
getScratch = rec![SCRATCH]
End Function
Public Function getResultKey() As Integer
getResultKey = rec![resultKey]
End Function
Public Function getCount() As Integer
getCount = swim_count
End Function
Public Function getUnoff() As Boolean
getUnoff = rec![unofficial]
End Function
Public Sub insertHeat(ht As Integer)
Dim found As Boolean
rec.moveFirst
found = False
While Not found
  found = rec.EOF
  If Not found Then
    found = (rec![heat] = ht)
  End If
  If Not found Then rec.moveNext
Wend
If found And Not rec.EOF Then
    While Not rec.EOF
     rec.Edit
     rec![heat] = rec![heat] + 1
     rec.update
     rec.moveNext
    Wend
End If
End Sub
Public Sub deleteHeat(ht As Integer)
'unseeds any swimmers in deleted heat
Dim found As Boolean
rec.moveFirst
found = False
While Not found
  found = rec.EOF
  If Not found Then
    found = (rec![heat] = ht)
  End If
  If Not found Then rec.moveNext
Wend
If found And Not rec.EOF Then
  While rec![heat] = ht
    rec.Edit
    rec![heat] = 0
    rec.update
    rec.moveNext
  Wend
End If
found = False
rec.moveFirst
While Not found
found = rec.EOF
  If Not found Then
    found = (rec![heat] = (ht + 1))
  End If
  If Not found Then rec.moveNext
Wend
'decrement heats that follow
    While Not rec.EOF
     rec.Edit
     rec![heat] = rec![heat] - 1
     rec.update
     rec.moveNext
    Wend

End Sub
